/*
 * $Id: sysdef.h,v 1.9 2012/02/06 21:05:11 pischky Exp $
 */

#ifndef _SYSDEF_H_
#define _SYSDEF_H_

#include <avr/io.h>		// [we need all register and port definitions]

//---------------------- general definitions ------------------------------

#ifndef F_CPU
  #define F_CPU 8000000 // use ext. Quarz with 7.3728MHz
#endif

#define EEPROM_DSTL 3 //SV_ADDR_SERIAL_NUMBER_L  // serial number and address (aka "ID" shall be equal)
#define EEPROM_DSTH 4 //SV_ADDR_SERIAL_NUMBER_H

#define BOARD_DEFINED_IN_SYSDEF 

//--------------- configuration for ln_swtx_hwrx_uart.c --------------------------
	// using UART 0, Timer 1 with ouput capture A
	
	#define LN_RX_PORT   PIND   // PD0 = RXD
	#define LN_RX_BIT    PORTD0
	
	#define LN_TX_PORT   PORTD  // PD1 = TXD
	#define LN_TX_DDR    DDRD
	#define LN_TX_BIT    PORTD1
	
	#define LN_PCI_NO    16  // PD0 = RXD = PCINT16		//Original-Watti



//Original-Watti	
//	#define LN_SW_UART_SET_TX_LOW  cbi(LN_TX_PORT, LN_TX_BIT);  // to pull down LN line to drive low level
//	#define LN_SW_UART_SET_TX_HIGH sbi(LN_TX_PORT, LN_TX_BIT);  // master pull up will take care of high LN level

#define LN_SW_UART_SET_TX_LOW  {sbi(LN_TX_PORT, LN_TX_BIT);\
                                sbi(LN_TX_DDR,  LN_TX_BIT);}  // to pull down LN line to drive low level

                                                              // tristating pin to switch off NPN transistor
#define LN_SW_UART_SET_TX_HIGH {cbi(LN_TX_PORT, LN_TX_BIT);\
                                cbi(LN_TX_DDR,  LN_TX_BIT);}  // master pull up will take care of high LN level





	#define LN_SB_SIGNAL          TIMER1_CAPT_vect
	#define LN_SB_INT_ENABLE_REG  TIMSK1
	#define LN_SB_INT_ENABLE_BIT  ICIE1
	#define LN_SB_INT_STATUS_REG  TIFR1
	#define LN_SB_INT_STATUS_BIT  ICF1
	
	#define LN_TMR_SIGNAL         TIMER1_COMPA_vect
	#define LN_TMR_INT_ENABLE_REG TIMSK1
	#define LN_TMR_INT_ENABLE_BIT OCIE1A
	#define LN_TMR_INT_STATUS_REG TIFR1
	#define LN_TMR_INT_STATUS_BIT OCF1A
	#define LN_TMR_OUTP_CAPT_REG  OCR1A
	#define LN_TMR_COUNT_REG      TCNT1
	#define LN_TMR_CONTROL_REG    TCCR1B
	
	#define LN_TMR_PRESCALER      1
	
	#define LN_HW_UART_CONTROL_REGA UCSR0A
	#define LN_HW_UART_CONTROL_REGB UCSR0B
	#define LN_HW_UART_BAUDRATE_REG UBRR0L
	#define LN_HW_UART_RX_SIGNAL   USART_RX_vect
//	#define LN_HW_UART_RX_SIGNAL    SIG_USART_RECV //atmega168
	//#define LN_HW_UART_TX_SIGNAL    SIG_UART_DATA
	#define LN_HW_UART_DATA_REG     UDR0
	
//	#define LN_SW_UART_TX_NON_INVERTED  //F�r Original Watti-Hardware

//---- Drehregler-Zeug


#define PHASE_B (PINC & 1 <<PINC5)
#define PHASE_A	(PINC & 1 <<PINC4)


//----------------------------- Tastatur-Definitionen-------------------------

#define COL_PORT 	PORTB
#define COL_DDR		DDRB

#define COL_1	2
#define COL_2	3
#define COL_3	4
#define COL_4	5

#define ROW_PORT	PORTC
#define ROW_PIN		PINC
#define ROW_DDR		DDRC

#define ROW_1	0
#define ROW_2	1
#define ROW_3	2
#define ROW_4	3


//LCD


#define LCD_DATA_PORT    PORTD     /* port for Databits */
#define LCD_DATA_DDR     DDRD      /* port for Databits */

#define LCD_DATA_D4_PIN  4
#define LCD_DATA_D5_PIN  5
#define LCD_DATA_D6_PIN  6
#define LCD_DATA_D7_PIN  7

#define LCD_RS_PORT      PORTD     /* port for RS line */
#define LCD_RS_DDR       DDRD      /* port for RS line */
#define LCD_RS_PIN       2

#define LCD_E_PORT       PORTD  	 /* port for Enable line */
#define LCD_E_DDR        DDRD      /* port for Enable line */
#define LCD_E_PIN        3



//----------------------------- legacy definitions --------------------------


#define BV(bit) _BV(bit)
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))





// ------------------------------------------------------------------------

#endif 
